> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List lineage for a report

GET https://api.sigmacomputing.com/v2/reports/{reportId}/lineage

This endpoint lists the data elements in a report and their dependencies and relationships, providing a detailed view of how data is interconnected within a report.

  ### Usage notes
  - Retrieve the **reportId** by calling the [/v2/reports](https://help.sigmacomputing.com/reference/list-reports) endpoint.

  ### Usage scenarios
  - **Data governance:** Allows data managers to track how information is used and propagated through different report elements.
  - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or report structure.
  - **Data source management**: Identify the dependencies of data sources in use in a specific report.

  ### Best practices
  - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
  - Use this endpoint to regularly audit report structures, ensuring that all data connections and transformations are correct and optimized.

Reference: https://help.sigmacomputing.com/reference/list-report-lineage-tree

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/reports/{reportId}/lineage:
    get:
      operationId: listReportLineageTree
      summary: List lineage for a report
      description: >-
        This endpoint lists the data elements in a report and their dependencies
        and relationships, providing a detailed view of how data is
        interconnected within a report.

          ### Usage notes
          - Retrieve the **reportId** by calling the [/v2/reports](https://help.sigmacomputing.com/reference/list-reports) endpoint.

          ### Usage scenarios
          - **Data governance:** Allows data managers to track how information is used and propagated through different report elements.
          - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or report structure.
          - **Data source management**: Identify the dependencies of data sources in use in a specific report.

          ### Best practices
          - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
          - Use this endpoint to regularly audit report structures, ensuring that all data connections and transformations are correct and optimized.
      tags:
        - Reports
      parameters:
        - name: reportId
          in: path
          required: true
          schema:
            type: string
        - name: pageToken
          in: query
          required: false
          schema:
            type: string
        - name: pageSize
          in: query
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/reports_listReportLineageTree_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
        sourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: >-
            List of direct sources for the element. Either element IDs or data
            source IDs.
        elementId:
          type: string
          description: Unique identifier of the element
        dataSourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: List of root sources for the element as data source IDs.
      required:
        - type
        - sourceIds
        - elementId
        - dataSourceIds
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        dataModelId:
          type: string
      required:
        - type
        - connectionId
        - name
        - dataModelId
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        inodeId:
          type: string
      required:
        - type
        - connectionId
        - name
        - inodeId
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        definition:
          type: string
      required:
        - type
        - connectionId
        - name
        - definition
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        csvId:
          type: string
          description: Unique identifier of the uploaded CSV file
      required:
        - type
        - connectionId
        - name
        - csvId
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf5Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
        - semantic-view
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf5Type
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems5:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf5Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        semanticViewId:
          type: string
          description: Unique identifier of the semantic view
        semanticViewTable:
          type: string
          description: Name of the table within the semantic view
      required:
        - type
        - connectionId
        - name
        - semanticViewId
        - semanticViewTable
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems5
    V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems:
      oneOf:
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
        - $ref: >-
            #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems5
      title: >-
        V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
    reports_listReportLineageTree_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ReportsReportIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
          description: Array of results returned by the endpoint
        nextPageToken:
          type: string
          description: >-
            A string that can be passed to the `pageToken` parameter in the next
            request to fetch the next page of results. Not present in the last
            page of results.

            **Must be treated as an opaque string.**
      required:
        - entries
      title: reports_listReportLineageTree_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Response**

```json
{
  "entries": [
    {
      "dataSourceIds": [
        "string"
      ],
      "elementId": "string",
      "sourceIds": [
        "string"
      ],
      "type": "table"
    }
  ],
  "nextPageToken": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/reports/reportId/lineage"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/reports/reportId/lineage';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/reports/reportId/lineage"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/reports/reportId/lineage")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/reports/reportId/lineage")
  .header("Authorization", "<token>.")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/reports/reportId/lineage', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/reports/reportId/lineage");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/reports/reportId/lineage")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```